package net.brutex.xservices.ws;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

import net.brutex.xservices.types.HostConnection;
import net.brutex.xservices.types.ReturnCode;
import net.brutex.xservices.util.BrutexNamespaces;

/**
 * @author brosenberger
 *
 */
@WebService(targetNamespace = BrutexNamespaces.WS_XSERVICES)
public interface ExecuteService {

	/**
	 * @param cmd
	 * @param args
	 * @param timeout
	 * @return
	 */
	@WebMethod(operationName = "runCommand")
	public abstract ReturnCode runCommand(
			@WebParam(name = "executable") String cmd,
			@WebParam(name = "argline") String args,
			@WebParam(name = "timeout") long timeout);

	/**
	 * @param cmd
	 * @param args
	 * @param timeout
	 * @return
	 */
	@WebMethod(operationName = "runCommandWithArgs")
	public abstract ReturnCode runCommandWithArgs(
			@WebParam(name = "executable") String cmd,
			@WebParam(name = "arg") String[] args,
			@WebParam(name = "timeout") long timeout);

	/**
	 * @param cmd
	 * @param args
	 * @return
	 */
	@WebMethod(operationName = "runCommandAsync")
	public abstract ReturnCode runCommandAsync(
			@WebParam(name = "executable") String cmd,
			@WebParam(name = "argline") String args);

	/**
	 * @param cmd
	 * @param args
	 * @return
	 */
	@WebMethod(operationName = "runCommandAsyncWithArgs")
	public abstract ReturnCode runCommandAsyncWithArgs(
			@WebParam(name = "executable") String cmd,
			@WebParam(name = "arg") String[] args);

	/**
	 * @param host
	 * @param cmd
	 * @param timeout
	 * @return
	 */
	@WebMethod(operationName = "runCommandWithSSH")
	public abstract ReturnCode runCommandWithSSH(
			@WebParam(name = "host") HostConnection host,
			@WebParam(name = "command") String cmd,
			@WebParam(name = "timeout") long timeout);

	/**
	 * @param host
	 * @param keyfile
	 * @param cmd
	 * @param timeout
	 * @return
	 */
	@WebMethod(operationName = "runCommandWithSSHKeyAuth")
	public abstract ReturnCode runCommandWithSSHKeyAuth(
			@WebParam(name = "host") HostConnection host,
			@WebParam(name = "keyfile") String keyfile,
			@WebParam(name = "command") String cmd,
			@WebParam(name = "timeout") long timeout);

	/**
	 * @param host
	 * @param cmd
	 * @param timeout
	 * @return
	 */
	@WebMethod(operationName = "rExec")
	public abstract ReturnCode rExec(
			@WebParam(name = "host") HostConnection host,
			@WebParam(name = "command") String cmd,
			@WebParam(name = "timeout") long timeout);

	/**
	 * @param host
	 * @param prompt
	 * @param cmd
	 * @param expect
	 * @param timeout
	 * @return
	 */
	@WebMethod(operationName = "telnet")
	public abstract ReturnCode runTelnet(
			@WebParam(name = "host") HostConnection host,
			@WebParam(name = "prompt") String prompt,
			@WebParam(name = "command") String cmd,
			@WebParam(name = "expect") String expect,
			@WebParam(name = "timeout") long timeout);

}